%global momorel 1

Name: rails
Version: 1.1.6
Release: %{momorel}m
Summary: Web-application framework with template engine, control-flow layer, and ORM.
License: MIT/X
Group: Development/Libraries
%NoSource 0 http://rubyforge.org/frs/download.php/12323/rails-%{version}.tgz f4c8113474b35b7868483b1b561ec030
Source1: usr-bin-rails.rb
Patch0: rails-1.1.4.symlink.patch
URL: http://www.rubyonrails.org/
BuildRequires: coreutils
BuildRequires: tar
BuildRequires: sed
Requires: rake >= 0.7.1
Requires: ruby >= 1.8.2
Requires: ruby-activesupport = 1.3.1
Requires: ruby-activerecord = 1.14.3
Requires: ruby-actionpack = 1.12.3
Requires: ruby-actionmailer = 1.2.3
Requires: ruby-actionwebservice = 1.1.4
Requires: util-linux
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Rails is a framework for building web-application using CGI, FCGI,
mod_ruby, or WEBrick on top of either MySQL, PostgreSQL, SQLite, DB2,
SQL Server, or Oracle with eRuby- or Builder-based templates.

%package -n ruby-activesupport
Version: 1.3.1
Summary: Support and utility classes used by the Rails framework.
Group: Development/Libraries
Requires: ruby >= 1.8.2
%description -n ruby-activesupport
Utility library which carries commonly used classes and goodies
from the Rails framework

%package -n ruby-activerecord
Version: 1.14.3
Summary: Implements the ActiveRecord pattern for ORM.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-activesupport = 1.3.1
%description -n ruby-activerecord
Implements the ActiveRecord pattern (Fowler, PoEAA) for ORM. It
ties database tables and classes together for business objects,
like Customer or Subscription, that can find, save, and destroy
themselves without resorting to manual SQL.

%package -n ruby-actionpack
Version: 1.12.3
Summary: Web-flow and rendering framework putting the VC in MVC.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-activesupport = 1.3.1
%description -n ruby-actionpack
Eases web-request routing, handling, and response as a half-way
front, half-way page controller. Implemented with specific emphasis
on enabling easy unit/integration testing that doesn't require a browser.

%package -n ruby-actionmailer
Version: 1.2.3
Summary:  Service layer for easy email delivery and testing.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-actionpack = 1.12.3
%description -n ruby-actionmailer
Makes it trivial to test and deliver emails sent from a single service layer.

%package -n ruby-actionwebservice
Version: 1.1.4
Summary: Web service support for Action Pack.
Group: Development/Libraries
Requires: ruby >= 1.8.2
Requires: ruby-actionpack = 1.12.3
Requires: ruby-activerecord = 1.14.3
%description -n ruby-actionwebservice
Adds WSDL/SOAP and XML-RPC web service support to Action Pack

%global ruby_libdir %(ruby -rrbconfig -e 'puts Config::CONFIG["rubylibdir"]')
%global railsdir %{_datadir}/%{name}

%prep
%setup -q -n %{name}
%patch0 -p1

%install
%__rm -rf %{buildroot}

%__mkdir_p %{buildroot}%{_bindir}

# normalize sh-bang line of executable scripts
for cmd in vendor/rails/railties/dispatches/*.*; do
	%__sed '1s,^#!/usr/local/bin/ruby,#!/usr/bin/env ruby,' $cmd > $cmd.tmp
	%__mv -f $cmd.tmp $cmd
done

# fix permissions
find . -type d -exec %__chmod 755 '{}' \;
find . -type f -exec %__chmod 644 '{}' \;

%__mkdir_p %{buildroot}%{_datadir}/%{name}/railties
docdir=`pwd`/doc.railties
%__mkdir_p $docdir
pushd vendor/rails/railties

# save document
%__mv MIT-LICENSE CHANGELOG $docdir

%__tar cf - * | (cd %{buildroot}%{_datadir}/%{name}/railties; %__tar xf -)
popd

%__mkdir_p %{buildroot}%{ruby_libdir}
for dir in vendor/rails/ac*; do
	base=`basename $dir`
	docdir=`pwd`/doc.$base
	%__mkdir_p $docdir
	pushd $dir
	(cd lib; %__tar -cf - .) | (cd %{buildroot}%{ruby_libdir}; %__tar xf -)
	%__mv CHANGELOG README $docdir
	[ -f MIT-LICENSE ] && %__mv MIT-LICENSE $docdir
	[ -f TODO ] && %__mv TODO $docdir
	[ -d examples ] && %__mv examples $docdir
	popd
done

%__install -m755 %{SOURCE1} %{buildroot}%{_bindir}/rails

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc/api doc.railties/*
%{_bindir}/rails
%{_datadir}/%{name}

%files -n ruby-activesupport
%defattr(-,root,root)
%doc doc.activesupport/*
%{ruby_libdir}/active_support
%{ruby_libdir}/active_support.rb

%files -n ruby-activerecord
%defattr(-,root,root)
%doc doc.activerecord/*
%{ruby_libdir}/active_record
%{ruby_libdir}/active_record.rb

%files -n ruby-actionpack
%defattr(-,root,root)
%doc doc.actionpack/*
%{ruby_libdir}/action_pack
%{ruby_libdir}/action_pack.rb
%{ruby_libdir}/action_view
%{ruby_libdir}/action_view.rb
%{ruby_libdir}/action_controller
%{ruby_libdir}/action_controller.rb

%files -n ruby-actionmailer
%defattr(-,root,root)
%doc doc.actionmailer/*
%{ruby_libdir}/action_mailer
%{ruby_libdir}/action_mailer.rb

%files -n ruby-actionwebservice
%defattr(-,root,root)
%doc doc.actionwebservice/*
%{ruby_libdir}/action_web_service
%{ruby_libdir}/action_web_service.rb

%changelog
* Thu Aug 11 2006 zunda <zunda at freeshell.org>
- (1.1.6-1m)
- new version.

* Wed Aug  9 2006 zunda <zunda at freeshell.org>
- (1.1.5-1m)
- new version.

* Fri Jul 28 2006 zunda <zunda at freeshell.org>
- (1.1.4-2m)
- rails-1.1.4.symlink.patch: added to make a symlink when not frozen for
  Momonga without gems
- usr-bin-rails.rb: renamed from rails.sh, modified accordingly

* Fri Jun 30 2006 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.1.4-1m)
- new version.

* Thu Jun 29 2006 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.1.3-1m)
- new version.

* Fri Dec 14 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (1.0.0-1m)
- new version.

* Fri Dec 09 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.14.4-1m)
- new version. (This version is a.k.a. RC5)

* Tue Nov 15 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.14.3-1m)
- new version. (This version is a.k.a. RC4)
- split into subpackages and define dependencies among them.

* Thu Sep 22 2005 OZAWA Sakuro <crouton@momonga-linux.org> 
- (0.13.1-4m)
- fix clean logger problem on Ruby 1.8.3.

* Mon Aug  1 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-3m)
- add a note to config/environment.rb about using Rails' fallback MySQL interface in Momonga.

* Sun Jul 31 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-2m)
- fix sh-bang normalization (esp. for script/runner).
- fix building requirement.

* Sat Jul 30 2005 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.13.1-1m)
